%global	header_dir	%{ruby_vendorarchdir}

%global	gem_name	glib2

%global	obsoleteevr	0.90.7-1.999

Summary:	Ruby binding of GLib-2.x
Name:		rubygem-%{gem_name}
Version:	2.2.0
Release:	%mkrel 1
Group:		Development/Ruby
License:	LGPLv2
URL:		http://ruby-gnome2.sourceforge.jp/
Source0:	http://rubygems.org/gems/%{gem_name}-%{version}.gem
Patch100:	rubygem-glib2-1.2.1-rubywrapper-pollutes-env.patch
Requires:	ruby(release)
BuildRequires:	ruby(release)
BuildRequires:	rubygems-devel
BuildRequires:	rubygem-pkg-config
BuildRequires:	ruby-devel
BuildRequires:	glib2-devel
BuildRequires:	rubygem-test-unit
Requires:	rubygems
Provides:	rubygem(%{gem_name}) = %{version}-%{release}
Obsoletes:	ruby-%{gem_name} <= %{version}-%{release}
Provides:	ruby-%{gem_name} = %{version}-%{release}
Provides:	ruby(%{gem_name}) = %{version}-%{release}

%description
Ruby/GLib2 is a Ruby binding of GLib-2.x.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%package	devel
Summary:	Ruby/GLib development environment
Group:		Development/Ruby
Requires:	%{name} = %{version}-%{release}
Requires:	glib2-devel
Requires:	ruby-devel
Requires:	rubygem-pkg-config
Requires:	rubygem-rake-compiler
Obsoletes:	ruby-%{gem_name}-devel < %{obsoleteevr}
Provides:	ruby-%{gem_name}-devel = %{version}-%{release}

%description devel
Header files and libraries for building a extension library for the
rubygem-%{gem_name}

%prep
%setup -q -c -T

TOPDIR=$(pwd)
mkdir tmpunpackdir
pushd tmpunpackdir

gem unpack %{SOURCE0}
cd %{gem_name}-%{version}

gem specification -l --ruby %{SOURCE0} > %{gem_name}.gemspec

# Patches and etc
%patch100 -p1

# Make pkg-config devel dependency (not runtime)
sed -i \
	-e '\@pkg-config@s|add_\(runtime_\)*dependency|add_development_dependency|' \
	%{gem_name}.gemspec \
	Rakefile

sed -i \
	-e '2a require "rubygems"\ngem "test-unit"\n' \
	test/run-test.rb

# shebang issue
find sample/ test/ -name \*.rb | xargs chmod 0644
grep -rl '#![ ]*/usr' sample/ test/ | \
	xargs chmod 0755

# Repackage gem
gem build %{gem_name}.gemspec
mv %{gem_name}-%{version}.gem $TOPDIR

popd
rm -rf tmpunpackdir

%build
export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
export CONFIGURE_ARGS="$CONFIGURE_ARGS --with-pkg-config-dir=$(pwd)%{_libdir}/pkgconfig"
%gem_install

# Move C extension library to some private directory
pushd .%{gem_instdir}

# create glib-test-init.rb
cat > lib/glib-test-init.rb <<EOF
\$VERBOSE = true
begin
	require 'rubygems'
	gem 'test-unit'
rescue LoadError
end
require 'test/unit'
EOF

%install
# Once copy all
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
	%{buildroot}%{gem_dir}/

# move header files, C extension files to the correct directory
mkdir -p %{buildroot}%{gem_extdir_mri}
cp -a ./%{gem_extdir_mri}/* %{buildroot}%{gem_extdir_mri}/

pushd %{buildroot}
mkdir -p .%{header_dir}
mv .%{gem_extdir_mri}/*.h .%{header_dir}/
rm -f .%{gem_extdir_mri}/{gem_make.out,mkmf.log}
popd

# move pkgconfig file
mkdir %{buildroot}%{_libdir}/pkgconfig
install -cpm 644 ./%{_libdir}/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig/


# Cleanups
pushd %{buildroot}
rm -rf .%{gem_instdir}/ext/
rm -f .%{gem_instdir}/extconf.rb
popd


%files
%defattr(-,root,root,-)
%dir	%{gem_instdir}
%dir	%{gem_instdir}/lib/

%doc	%{gem_instdir}/[A-Z]*
%exclude	%{gem_instdir}/Rakefile

%{gem_instdir}/lib/glib2.rb
%{gem_instdir}/lib/glib-mkenums.rb
%dir %{gem_instdir}/lib/glib2
%{gem_instdir}/lib/glib2/deprecatable.rb

%{gem_extdir_mri}/

%exclude	%{gem_cache}
%{gem_spec}

%files	devel
%defattr(-,root,root,-)
# Using pkg-config and mkmf, let's move mkmf-gnome2.rb into -devel
# gnome2-raketask.rb uses rake-compiler, so also put this into -devel
# Also install gliglib-test-init.rb
%{gem_instdir}/lib/glib-test-init.rb
%{gem_instdir}/lib/gnome2-raketask.rb
%{gem_instdir}/lib/mkmf-gnome2.rb
%dir	%{gem_instdir}/lib/gnome2/
%dir	%{gem_instdir}/lib/gnome2/rake/
%{gem_instdir}/lib/gnome2/rake/*.rb

%{header_dir}/rbgcompat.h
%{header_dir}/rbglib.h
%{header_dir}/rbglibdeprecated.h
%{header_dir}/rbglib2conversions.h
%{header_dir}/rbgobject.h
%{header_dir}/rbgutil.h
%{header_dir}/rbgutil_list.h
%{header_dir}/rbgutildeprecated.h
%{header_dir}/glib-enum-types.h
%{_libdir}/pkgconfig/ruby-%{gem_name}.pc

%files	doc
%defattr(-,root,root,-)
%{gem_docdir}/
%exclude	%{gem_instdir}/Rakefile
%{gem_instdir}/sample/
%{gem_instdir}/test/


%changelog
* Fri Oct 31 2014 bb <bb> 2.2.0-1pclos2014
- import
